#ifndef __SHMEM_H__
#define __SHMEM_H__

typedef unsigned long ULONG;

#define USESHMEM
//#define USESEM

#ifdef USESHMEM

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define FL_USESHMEM    0x01
#define FL_DOUNTUSESEM 0x02
#define FL_GETVERSION  0x04

#define PERM 0666

//data struct in shared memory
typedef struct mem_param
 {
  char IdS[16];
  ULONG ShMSize;
  key_t ShMKey;
  ULONG flags;
 } MemParam;

typedef struct mem_for_use
 {
  MemParam params;
  char buf[4];
 } MemForUse;

#define MemAlignment         0x1000  //4096 
 
#ifdef USESEM

#include <sys/sem.h>

// wait of client action start 
static struct sembuf proc_wait[1]={{1,-1,0}};

// notification to server about client action start
static struct sembuf proc_start[1]={{1,1,0}};

// blocade shared memory
static struct sembuf mem_lock[2]={ {0,0,0}, {1,1,0} };

// discharge memory
static struct sembuf mem_unlock[1]={{0,1,0}};
#endif

#endif

#endif
