#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <time.h>
#include <paths.h>
#include <errno.h>
#include "workstat.h"

typedef struct
 {
  unsigned long int cek;
  struct tm Tm;

  unsigned long int PureObjects;	
  unsigned long int ScanBreak;	
  unsigned long int Warning;	
  unsigned long int Suspision;	
  unsigned long int Detected;	
  unsigned long int Disinfect;	
  unsigned long int Deleted;	
  unsigned long int Corripted;	
  unsigned long int ExeCorript;	
 } __attribute__ ((packed)) _localworkStat;

_localworkStat lWorkStat;

void IniWorkStat(void)
 {
  time_t Timer;
  struct tm *Tm;

  Timer=time((time_t*)NULL);
  Tm=localtime(&Timer);
  lWorkStat.cek=Tm->tm_mday*86400+Tm->tm_hour*3600+Tm->tm_min*60+Tm->tm_sec;
  lWorkStat.Tm.tm_hour=lWorkStat.Tm.tm_min=lWorkStat.Tm.tm_sec=0;

  lWorkStat.PureObjects=0;
  lWorkStat.ScanBreak=0;
  lWorkStat.Warning=0; 
  lWorkStat.Suspision=0;
  lWorkStat.Detected=0;
  lWorkStat.Disinfect=0;
  lWorkStat.Deleted=0;
  lWorkStat.Corripted=0;
  lWorkStat.ExeCorript=0;
 }

void IncWorkStat(int sw)
 {
  switch (sw)
   {
    case INCL_OK:	 ++lWorkStat.PureObjects;   break; // number of pure objects
    case INCL_SCANBREAK: ++lWorkStat.ScanBreak;     break; // number of interrupted scan
    case INCL_WARNING:	 ++lWorkStat.Warning;       break; // number of objects with warnings
    case INCL_SUSPICION: ++lWorkStat.Suspision;     break; // number of suspicious objects
    case INCL_DETECTED:	 ++lWorkStat.Detected;      break; // number of deleted objects
    case INCL_DISINFECT: ++lWorkStat.Disinfect;     break; // number of disinfected objects
    case INCL_DELETED:	 ++lWorkStat.Deleted;       break; // number of objects with deleted viruses
    case INCL_CORRUPTED: ++lWorkStat.Corripted;     break; // number of corrupted objects
    case INCL_EXECORRUPTED: ++lWorkStat.ExeCorript; break; // execitable file corrupted!
   }
 }

int ReportWorkStat(char* szCurName)
 {
  time_t Timer;
  struct tm *Tm;

  Timer =time((time_t*)NULL);
  Tm=localtime(&Timer);
  lWorkStat.cek=Tm->tm_mday*86400+Tm->tm_hour*3600+Tm->tm_min*60+Tm->tm_sec-lWorkStat.cek;
  if(lWorkStat.cek==0) lWorkStat.cek=1;
  lWorkStat.Tm.tm_sec =(unsigned char)((lWorkStat.cek%3600)%60);
  lWorkStat.Tm.tm_min =(unsigned char)((lWorkStat.cek%3600)/60);
  lWorkStat.Tm.tm_hour=(unsigned char)(lWorkStat.cek/3600);

  if(lWorkStat.ExeCorript!=0)
    printf("Execitable file corrupted!\n");
  if(szCurName!=NULL) printf("\nCurrent object: %s\n",szCurName);
  printf("Number of pure objects:                              %6ld\n",lWorkStat.PureObjects);
  printf("Number of objects with detected viruses              %6ld\n",lWorkStat.Detected);
  printf("Number of disinfected objects:                       %6ld\n",lWorkStat.Disinfect);
  printf("Number of deleted objects:                           %6ld\n",lWorkStat.Deleted);
  printf("Number of suspicious objects:                        %6ld\n",lWorkStat.Suspision);
  printf("Number of objects with corrupted or changed viruses: %6ld\n",lWorkStat.Warning);
  printf("Number of corrupted(or disabled) objects             %6ld\n",lWorkStat.Corripted);
  printf("Number of interrupted scan                           %6ld\n",lWorkStat.ScanBreak);
  printf("Scan time:                                         %02d:%02d:%02d\n",lWorkStat.Tm.tm_hour,lWorkStat.Tm.tm_min,lWorkStat.Tm.tm_sec);

  int ExitCode=0;
  if(lWorkStat.Corripted)  ExitCode=8;
  if(lWorkStat.Suspision)  ExitCode=3;
  if(lWorkStat.Warning)    ExitCode=2;

  if((lWorkStat.Detected) || (lWorkStat.Disinfect) || (lWorkStat.Deleted)) ExitCode=4;

  return ExitCode;
 }
  

